/* polish math functions */
#include "ddc-g.h"
#include <math.h>
#include "p_math.h"

extern daton* Eptr;

#define doit(NN, OP) void NN() {  *(Eptr-1) = (*(Eptr-1) OP *Eptr) ;  Eptr--; }

doit(Plus, + )
doit(Minus, - )
doit(Times, * )
doit(Div, / )
doit(P_eq, == )
doit(P_neq, != )
doit(P_geq, >= )
doit(P_leq, <= )
doit(P_greater, > )
doit(P_less, < )

void Exch() {
  daton temp;
  temp = *Eptr;
  *(Eptr) = *(Eptr-1);
  *(Eptr-1) = temp;
}

void Or() {
  *(Eptr-1) = (int)(*(Eptr-1)) | (int)(*(Eptr));
  Eptr--;
}

void And() {
  *(Eptr-1) = (int)(*(Eptr-1)) & (int)(*(Eptr));
  Eptr--;
}

void Neg() {  *Eptr = - (*Eptr); }

/* XX mod YY */
/* answer is always >= 0 */
/* and always < |YY| */
/* which is NOT equivalent to the built-in "%" operator */
void P_mod() {
  *(Eptr)   = fabs(*(Eptr));    /* modulus always positive */
  *(Eptr-1) = *(Eptr-1) - *Eptr * floor(*(Eptr-1) / *Eptr);
  Eptr--;
}

void SixtyPlus() {
  *(Eptr-1) = *(Eptr-1)*60. + *Eptr;
  Eptr--;
}

#include <sys/types.h>
#include <sys/timeb.h>
#include "bison_ifc.h"
void P_time() {
  struct timeb foo;
  daton ddd;
  ftime(&foo);
  ddd = foo.time + foo.millitm / 1000.;
  push(ddd);
}
