/*
// random number generator
// uses table set up by rand.c
// polish interface for use by dcc
*/

#include <cmath>
#include "bison_ifc.h"
#include "ddc-g.h"
extern long randomtab[], *randomjay, *randomkay;

extern void push();
extern daton* Eptr;

/*
////////////////////////////////////////
// (31 bit integer) random number
*/
long irand() {
    if (++randomjay >= &randomtab[98]) randomjay -= 98;
    if ((randomkay = randomjay + 27) >= &randomtab[98]) randomkay -= 98;
    return(*randomjay ^= *randomkay);
}

#define two31m1 2147483647.

/* uniform on the interval [0 .. 1.0] */
void P_random() {
  push((daton) irand() / (daton) two31m1);
}

/* gaussian random noise */
/* zero mean, unit variance */
/* NOT IMPLEMENTED */
void P_whitenoise() {
  push(0.0);
}
